/*
 * emuboot.h
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
#define ROOTDIR	"/tftpboot"
#define DISKDEV "disk1:"	/* HD, disk0 is FD */
#define NETDEV	"pxe0:"

struct boot_what;
struct in_addr;

int bootinfo_getinfo(struct boot_what **boot_whatp);
void bootinfo_showinfo(void);
int parse_multiboot_spec(char *cline, struct in_addr *ip, char **path,
			 char **args);
int load_multiboot_image(struct in_addr *server, char *filename, char *cmdline);
int boot_mbr_sysid(int sysid);
int boot_mbr_partition(int partition);
void boot_interactive(void);
void boot_mbr_default(void);
void disk_showinfo(void);
int set_active(int apart);
