/*
 * math_emu.h
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
/*
 *
 * $FreeBSD: src/sys/gnu/i386/fpemul/math_emu.h,v 1.5 1999/08/28 00:42:52 peter Exp $
 *
 */

#ifndef _MATH_EMU_H
#define _MATH_EMU_H

struct fpu_reg {
	char    sign;
	char    tag;
	long    exp;
	u_long  sigl;
	u_long  sigh;
};

union i387_union {
	struct i387_hard_struct {
		long    cwd;
		long    swd;
		long    twd;
		long    fip;
		long    fcs;
		long    foo;
		long    fos;
		long    st_space[20];	/* 8*10 bytes for each FP-reg = 80
					 * bytes */
	}       hard;
	struct i387_soft_struct {
		long    cwd;
		long    swd;
		long    twd;
		long    fip;
		long    fcs;
		long    foo;
		long    fos;
		long    top;
		struct fpu_reg regs[8];	/* 8*16 bytes for each FP-reg = 128
					 * bytes */
		unsigned char lookahead;
		struct trapframe *frame;
		unsigned long entry_eip;
		int     orig_eip;
	}       soft;
};
#endif
