/*
 * cycmap.h
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
#ifndef CYC_MAP_H
#define CYC_MAP_H

/* Illegally typecast char * to struct definitions. The only condition we have right now
   is that the struct should be bits-only.
   And of course, the size of the char array should be greater than the size
   of the struct being cast to.
*/
struct xudphdr;
struct xtcphdr;
struct xudpiphdr;
struct ipovly;
struct xtcptemp;

namespace UnsafeTFI {
	extern "C include" {  /* tell Cyclone that <cmap.h> is C code */
                #include <netinet/xtcp/cmap.h>
	} export {
		/* export these functions */
		tfi_strtoxudphdr, tfi_strtoxudpiphdr, tfi_strtoipovly,
			tfi_mtoxtcptemp, tfi_strtoxtcphdr, tfi_xtcptemptom;
	}
}

struct xudphdr *tfi_strtoxudphdr(char ? @nozeroterm data);
struct xudpiphdr *tfi_strtoxudpiphdr(char ? @nozeroterm data);
struct ipovly *tfi_strtoipovly(char ? @nozeroterm data);
struct xtcptemp *tfi_mtoxtcptemp(mbuf_t @m);
extern mbuf_t *tfi_xtcptemptom(struct xtcptemp *);
extern struct xtcphdr *tfi_strtoxtcphdr(char ? @nozeroterm data);
// #define tfi_strtoxtcphdr UnsafeTFI::tfi_strtoxtcphdr

#endif /* CYC_MAP_H */
