/*
 * tfc_error.h
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
#ifndef TFC_ERROR_H

#define TFC_SUCCESS 0
#define TFC_NOERROR 0

#define TFC_ENOSUPPORT         -1001 /* proto not supported */
#define TFC_EINUSE             -1002 /* protocol in use */
#define TFC_INVALIDPROTO       -1003 
#define TFC_EXISTS             -1004 /* protocol exists */
#define TFC_ENOMEM             -1005 
#define TFC_EARGS              -1006 /* invalid args */
#define TFC_EISCONN            -1007 /* socket connected */
#define TFC_EINVAL             -1008 /* Invalid */

#define TFC_ERROR               -1009 /* Generic error code */
#define TFI_ERROR               -1009 /* Generic error code */

#define TFC_NOPROTO             -1010 /* No proto found at input */
#define TFC_BADNONCE            -1011 /* bad nonce */
#define TFC_EINVALSEQ           -1012 /* Invalid */
#define TFC_WAIT                -1013 /* Wait until the equation lets you go */
#define TFC_GOAWAY              -1014 /* bad transport */
#define TFC_SBOF                -1015 /* scoreboard overflow */

#define TFC_EXCEPTION           -1016 /* Exception thrown from cyclone code */
#define TFC_OOORESEND           -1017 /*
				       * Protocol is trying to resend out-of-order
                                       * This maybe supported in the future
				       */
#define TFC_NOLISTENPROTO       -1018 /* No negotiated proto found on a listen
					 socket */

#endif /* TFC_ERROR_H */
