/*
 * tfc_stats.h
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */
#ifndef TFC_STATS_H
#define TFC_STATS_H

struct tfc_stats {
	int protomemfail;
	int tcps_conndrops;
	int tcps_closed;
	int recvtotal;
	int nodmdrops;
	int noport_drops;
	int noproto_drops;
	int fasttimo;
	int slowtimo;
	int protoattached;
	int sendnoconn;
	int sendtotal;
	int acktotal;
	int nacktotal;
	int acksent;
	int badnonce;
	int input_drops;
	int sb_overflows;
	int xtp_rcvshort;
	int high_rttign;
	int rate_ok;
	int rate_over;
	int ss_over; /* over rate in slow start mode */
	int ss_ok; /* slow start okay */
	int twice_rate; /* more than twice the allowed rate */
	int nofeed;
	int uncaught; /* uncaught exceptions */
	int initsent; /* packets sent in initrtt state */
	int connattempt; /* connection attempts */
};

extern struct tfc_stats tfc_stats;

#endif /* TFC_STATS_H */
