/*
 * xtcps_mod_cyc.c
 *
 * Copyright (c) 2005 The University of Utah and the Flux Group.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * for any purpose with or without fee is hereby granted, provided
 * that the above copyright notice and this permission notice
 * appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE UNIVERSITY OF UTAH
 * DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
 * EVENT SHALL THE UNIVERSITY OF UTAH BE LIABLE FOR ANY SPECIAL,
 * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */

#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/module.h>
#include <sys/conf.h>

#include <netinet/xtcp/tfi.h>
#include <netinet/xtcp/tfc.h>
#include <netinet/xtcp/tfci.h>

#include <xtcp_extensions/cycsacktcp/xtcp_mod.h>

#define CYCLONE_SYM(sym) Cyc_##sym
#define XCYCLONE_SYM(sym) CYCLONE_SYM(sym)

extern struct tfi_protosw_cyc XCYCLONE_SYM(xtcps_sw);

struct tfi_proto Cyc_xtcps_pr;

static int
xtcp_modevent(module_t mod, int type, void *data)
{
	int retval = 0;
	
	switch (type) {
	case MOD_LOAD:
		printf("\nXTCP protocol: CYCSACKTCP\n");
		retval = tfi_addproto_cyc(IPPROTO_XTCP,
					  0xb5,
					  &XCYCLONE_SYM(xtcps_sw),
					  &Cyc_xtcps_pr);
		printf("xtcps_init(NULL) = %d\n", retval);
		break;

	case MOD_UNLOAD:
#if !defined(KLD_MODULE)
		printf("xtcp proto tcp statically compiled, cannot unload\n");
		return EINVAL ;
#else
		printf("tfi_delproto(%p)\n", &Cyc_xtcps_pr);
		retval = tfi_delproto(&Cyc_xtcps_pr);
		printf("%d\n", retval);
#endif
		break ;
	default:
		break ;
	}
	return retval;
}

static moduledata_t xtcp_proto_cycsacktcp_mod = {
	"xtcp_proto_cycsacktcp",
	xtcp_modevent,
	NULL
};
DECLARE_MODULE(xtcp_proto_cycsacktcp, xtcp_proto_cycsacktcp_mod, SI_SUB_PROTO_DOMAIN, SI_ORDER_ANY);
MODULE_VERSION(xtcp_proto_cycsacktcp, 1);
